Index: issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 27035)
+++ issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 27232)
@@ -210,214 +275,241 @@
 
     for step in steplist:
-        print('Writing for step {}'.format(step))
+        if verbose > 2:
+            print('Writing for step {}'.format(step))
         saved_cells = {}
+        saved_edges = {}
         timestep = step
-        fid = open((filename + '/Timestep.vtk' + str(timestep) + '.vtk'), 'w+')
-        fid.write('# vtk DataFile Version 3.0 \n')
-        fid.write('Data for run {} \n'.format(md.miscellaneous.name))
-        fid.write('ASCII \n')
-        fid.write('DATASET UNSTRUCTURED_GRID \n')
-        fid.write('POINTS {:d} float\n'.format(num_of_points))
-    #updating z for mesh evolution
-        if moving_mesh and mesh_alti in ['1', '2']:
-            base = np.squeeze(res_struct.__dict__['TransientSolution'][step].__dict__['Base'][enveloppe_index])
-            thick_change_ratio = (np.squeeze(res_struct.__dict__['TransientSolution'][step].__dict__['Thickness'][enveloppe_index]) / md.geometry.thickness[enveloppe_index])
-            above_bed = points[:, 2] - md.geometry.base[enveloppe_index]
-            altitude = base + thick_change_ratio * above_bed
-        else:
-            altitude = points[:, 2]
-        for index, point in enumerate(points):
-            fid.write('{:f} {:f} {:f} \n'.format(point[0], point[1], altitude[index]))
-
-        fid.write('CELLS {:d} {:d}\n'.format(num_of_elt, num_of_elt * (point_per_elt + 1)))
-
-        for elt in range(0, num_of_elt):
-            if celltype == 5:
-                fid.write('3 {:d} {:d} {:d}\n'.format(connect[elt, 0],
-                                                      connect[elt, 1],
-                                                      connect[elt, 2]))
-            elif celltype == 13:
-                fid.write('6 {:d} {:d} {:d} {:d} {:d} {:d}\n'.format(connect[elt, 0],
-                                                                     connect[elt, 1],
-                                                                     connect[elt, 2],
-                                                                     connect[elt, 3],
-                                                                     connect[elt, 4],
-                                                                     connect[elt, 5]))
-
-        fid.write('CELL_TYPES {:d}\n'.format(num_of_elt))
-        for elt in range(0, num_of_elt):
-            fid.write('{:d}\n'.format(celltype))
-
-        fid.write('POINT_DATA {:s} \n'.format(str(num_of_points)))
+        with open((filename + '/Timestep.vtk' + str(timestep) + '.vtk'), 'w+') as fid:
+            fid.write('# vtk DataFile Version 3.0 \n')
+            fid.write('Data for run {} \n'.format(md.miscellaneous.name))
+            fid.write('ASCII \n')
+            fid.write('DATASET UNSTRUCTURED_GRID \n')
+            fid.write('POINTS {:d} float\n'.format(num_of_points))
+            #updating z for mesh evolution
+            if moving_mesh and mesh_alti in ['1', '2']:
+                base = np.squeeze(res_struct.__dict__['TransientSolution'][step].__dict__['Base'][enveloppe_index])
+                thick_change_ratio = (np.squeeze(res_struct.__dict__['TransientSolution'][step].__dict__['Thickness'][enveloppe_index]) / md.geometry.thickness[enveloppe_index])
+                above_bed = points[:, 2] - md.geometry.base[enveloppe_index]
+                altitude = base + thick_change_ratio * above_bed
+            else:
+                altitude = points[:, 2]
+            for index, point in enumerate(points):
+                fid.write('{:f} {:f} {:f} \n'.format(point[0], point[1], altitude[index]))
+
+            fid.write('CELLS {:d} {:d}\n'.format((num_of_elt + num_of_edges), num_of_elt  * (point_per_elt + 1) + num_of_edges * 3))
+
+            for elt in range(0, num_of_elt):
+                if celltype == 5:
+                    fid.write('3 {:d} {:d} {:d}\n'.format(connect[elt, 0],
+                                                          connect[elt, 1],
+                                                          connect[elt, 2]))
+                elif celltype == 13:
+                    fid.write('6 {:d} {:d} {:d} {:d} {:d} {:d}\n'.format(connect[elt, 0],
+                                                                         connect[elt, 1],
+                                                                         connect[elt, 2],
+                                                                         connect[elt, 3],
+                                                                         connect[elt, 4],
+                                                                         connect[elt, 5]))
+            for edge in range(0, num_of_edges):
+                fid.write('2 {:d} {:d}\n'.format(edges[edge, 0],
+                                                 edges[edge, 1]))
+
+            fid.write('CELL_TYPES {:d}\n'.format(num_of_elt + num_of_edges))
+            for elt in range(0, num_of_elt):
+                fid.write('{:d}\n'.format(celltype))
+                for edge in range(0, num_of_edges):
+                    fid.write('3\n')  #3 is for lines
+
+            fid.write('POINT_DATA {:s} \n'.format(str(num_of_points)))
+            # }}}
+            # {{{loop over the different solution structures
+            # first check if there are solutions to grab
+            if 'solnames' in locals():
+                for sol in solnames:
+                    treated_res = []
+                    #dealing with results on different timesteps
+                    try:
+                        if(len(res_struct.__dict__[sol]) > timestep):
+                            timestep = step
+                        else:
+                            timestep = np.size(res_struct.__dict__[sol])
+                    except TypeError:
+                        #result as no len() so no timesteps
+                        timestep = 1
+
+                    #getting the  fields in the solution
+                    if(type(res_struct.__dict__[sol]).__name__ == 'solution'):
+                        spe_res_struct = res_struct.__dict__[sol].__getitem__(timestep)
+                        fieldnames = list(dict.keys(spe_res_struct.__dict__))
+                    elif(type(res_struct.__dict__[sol]).__name__ == 'solutionstep'):
+                        spe_res_struct = res_struct.__dict__[sol]
+                        fieldnames = list(dict.keys(spe_res_struct.__dict__))
+                    elif(type(res_struct.__dict__[sol]).__name__ == 'results'):  #this is a result without steps
+                        spe_res_struct = res_struct.__dict__[sol]
+                        fieldnames = list(dict.keys(spe_res_struct.__dict__))
+                    else:
+                        print("WARNING, solution type '{}' is not recognise, exported results might be wrong".format(type(res_struct.__dict__[sol])))
+                        spe_res_struct = res_struct.__dict__[sol]
+                        fieldnames = list(dict.keys(spe_res_struct.__dict__))
+
+                    #Sorting scalars, vectors and tensors
+                    tensors = [field for field in fieldnames if field[-2:] in ['xx', 'yy', 'xy', 'zz', 'xz', 'yz']]
+                    non_tensor = [field for field in fieldnames if field not in tensors]
+                    vectors = [field for field in non_tensor if field[-1] in ['x', 'y', 'z'] and field[-4:] not in ['Flux']]
+                    #check which field is a real result and print
+                    for field in fieldnames:
+                        if verbose > 2:
+                            print("Treating {}".format(field))
+                        if field in treated_res:
+                            if verbose > 2:
+                                print("{} is already done".format(field))
+                            continue
+                        elif field in vectors:
+                            if verbose > 2:
+                                print("{} is a vector".format(field))
+                            try:
+                                Vxstruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'x'])
+                                Vystruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'y'])
+                                treated_res += [field[:-1] + 'x', field[:-1] + 'y']
+                                if dim == 3 and field[:-1] + 'z' in fieldnames:
+                                    #some fields like adjoint or always 2D
+                                    Vzstruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'z'])
+                                    treated_res += [field[:-1] + 'z']
+
+                            except KeyError:
+                                fieldnames += field
+                                vectors.remove(field)
+
+                            fid.write('VECTORS {} float \n'.format(field[:-1]))
+                            for node in range(0, num_of_points):
+                                Vx = cleanOutliers(Vxstruct[enveloppe_index[node]])
+                                Vy = cleanOutliers(Vystruct[enveloppe_index[node]])
+                                if dim == 3 and field[:-1] + 'z' in fieldnames:
+                                    Vz = cleanOutliers(Vzstruct[enveloppe_index[node]])
+                                    fid.write('{:f} {:f} {:f}\n'.format(Vx, Vy, Vz))
+                                else:
+                                    fid.write('{:f} {:f} {:f}\n'.format(Vx, Vy, 0))
+
+                        elif field in tensors:
+                            if verbose > 2:
+                                print("{} is a tensor".format(field))
+                            try:
+                                Txxstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xx'])
+                                Txystruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xy'])
+                                Tyystruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'yy'])
+                                treated_res += [field[:-2] + 'xx', field[:-2] + 'xy', field[:-2] + 'yy']
+                                if dim == 3:
+                                    Tzzstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'zz'])
+                                    Txzstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xz'])
+                                    Tyzstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'yz'])
+                                    treated_res += [field[:-2] + 'zz', field[:-2] + 'xz', field[:-2] + 'yz']
+
+                            except KeyError:
+                                fieldnames += field
+                                tensors.remove(field)
+
+                            fid.write('TENSORS {} float \n'.format(field[:-2]))
+                            for node in range(0, num_of_points):
+                                Txx = cleanOutliers(Txxstruct[enveloppe_index[node]])
+                                Tyy = cleanOutliers(Tyystruct[enveloppe_index[node]])
+                                Txy = cleanOutliers(Txystruct[enveloppe_index[node]])
+                                if dim == 3:
+                                    Tzz = cleanOutliers(Tzzstruct[enveloppe_index[node]])
+                                    Txz = cleanOutliers(Txzstruct[enveloppe_index[node]])
+                                    Tyz = cleanOutliers(Tyzstruct[enveloppe_index[node]])
+                                    fid.write('{:f} {:f} {:f}\n'.format(Txx, Txy, Txz))
+                                    fid.write('{:f} {:f} {:f}\n'.format(Txy, Tyy, Tyz))
+                                    fid.write('{:f} {:f} {:f}\n'.format(Txz, Tyz, Tzz))
+                                elif dim == 2:
+                                    fid.write('{:f} {:f} {:f}\n'.format(Txx, Txy, 0))
+                                    fid.write('{:f} {:f} {:f}\n'.format(Txy, Tyy, 0))
+                                    fid.write('{:f} {:f} {:f}\n'.format(0, 0, 0))
+                        else:
+                            if np.size(spe_res_struct.__dict__[field]) == 1:
+                                if field == 'time':
+                                    current_time = spe_res_struct.__dict__[field]
+                                    #skipping integers
+                                continue
+                            elif np.size(spe_res_struct.__dict__[field]) == every_nodes:
+                                fid.write('SCALARS {} float 1 \n'.format(field))
+                                fid.write('LOOKUP_TABLE default\n')
+                                for node in range(0, num_of_points):
+                                    outval = cleanOutliers(np.squeeze(spe_res_struct.__dict__[field][enveloppe_index[node]]))
+                                    fid.write('{:f}\n'.format(outval))
+                            elif np.shape(spe_res_struct.__dict__[field])[0] == np.size(spe_res_struct.__dict__[field]) == every_cells:
+                                saved_cells[field] = np.squeeze(spe_res_struct.__dict__[field])
+                            elif np.shape(spe_res_struct.__dict__[field])[0] == np.size(spe_res_struct.__dict__[field]) == every_edges:
+                                saved_edges[field] = np.squeeze(spe_res_struct.__dict__[field])
+                            else:
+                                print("format for field {}.{} is not suported, field is skipped".format(sol, field))
+            # }}}
+            # loop on arguments, if something other than result is asked, do it now {{{
+            for other in args:
+                other_struct = md.__dict__[other]
+                othernames = (dict.keys(other_struct.__dict__))
+                for field in othernames:
+                    if np.size(other_struct.__dict__[field]) == 1:
+                        #skipping integers
+                        continue
+                    elif np.size(other_struct.__dict__[field]) == every_nodes:
+                        fid.write('SCALARS {} float 1 \n'.format(field))
+                        fid.write('LOOKUP_TABLE default\n')
+                        for node in range(0, num_of_points):
+                            outval = cleanOutliers(other_struct.__dict__[field][enveloppe_index[node]])
+                            fid.write('{:f}\n'.format(outval))
+                    elif np.shape(other_struct.__dict__[field])[0] == every_nodes + 1:
+                        #we are dealing with a forcing of some kind.
+                        forcing_time = other_struct.__dict__[field][-1, :]
+                        if any(forcing_time == current_time):
+                            forcing_index = np.where(forcing_time == current_time)
+                            forcing_val = other_struct.__dict__[field][:, forcing_index]
+                        elif forcing_time[0] > current_time:
+                            forcing_val = other_struct.__dict__[field][:, 0]
+                        elif forcing_time[-1] < current_time:
+                            forcing_val = other_struct.__dict__[field][:, -1]
+                        else:
+                            forcing_index = np.where(forcing_time < current_time)[-1][-1]
+                            delta_time = forcing_time[forcing_index + 1] - forcing_time[forcing_index]  #compute forcing Dt
+                            delta_current = current_time - forcing_time[forcing_index]  # time since last forcing
+                            ratio = delta_current / delta_time  #compute weighting factor for preceding forcing vallue
+                            forcing_evol = (other_struct.__dict__[field][:, forcing_index + 1] - other_struct.__dict__[field][:, forcing_index]) * ratio
+                            forcing_val = other_struct.__dict__[field][:, forcing_index] + forcing_evol
+                        # and now write it down
+                        fid.write('SCALARS {}_{} float 1 \n'.format(other, field))
+                        fid.write('LOOKUP_TABLE default\n')
+                        for node in range(0, num_of_points):
+                            outval = cleanOutliers(forcing_val[enveloppe_index[node]])
+                            fid.write('{:f}\n'.format(outval))
+                    elif np.shape(other_struct.__dict__[field])[0] == np.size(other_struct.__dict__[field]) == every_cells:
+                        saved_cells[field] = other_struct.__dict__[field]
+                    elif np.shape(other_struct.__dict__[field])[0] == np.size(other_struct.__dict__[field]) == every_edges:
+                        saved_edges[field] = other_struct.__dict__[field]
+                    else:
+                        print("format for field {}.{} is not suported, field is skipped".format(other, field))
+                        continue
+            # }}}
+            # Now writting cell variables {{{
+            if np.size(list(saved_cells.keys())) > 0:
+                fid.write('CELL_DATA {:d} \n'.format(num_of_elt + num_of_edges))
+                for key in list(saved_cells.keys()):
+                    fid.write('SCALARS {} float 1 \n'.format(key))
+                    fid.write('LOOKUP_TABLE default\n')
+                    for cell in range(0, num_of_elt):
+                        outval = cleanOutliers(saved_cells[key][cell])
+                        fid.write('{:f}\n'.format(outval))
+                    for edge in range(0, num_of_edges):
+                        fid.write('{:f}\n'.format(-9999.999))
+            # }}}
+            # Now writting edge variables {{{
+            if np.size(list(saved_edges.keys())) > 0:
+                for key in list(saved_edges.keys()):
+                    fid.write('SCALARS {} float 1 \n'.format(key))
+                    fid.write('LOOKUP_TABLE default\n')
+                    for cell in range(0, num_of_elt):
+                        fid.write('{:f}\n'.format(-9999.999))
+                    for edge in range(0, num_of_edges):
+                        outval = cleanOutliers(saved_edges[key][edge])
+                        fid.write('{:f}\n'.format(outval))
     # }}}
-    # {{{loop over the different solution structures
-    # first check if there are solutions to grab
-        if 'solnames' in locals():
-            for sol in solnames:
-                treated_res = []
-                #dealing with results on different timesteps
-                try:
-                    if(len(res_struct.__dict__[sol]) > timestep):
-                        timestep = step
-                    else:
-                        timestep = np.size(res_struct.__dict__[sol])
-                except TypeError:
-                    #result as no len() so no timesteps
-                    timestep = 1
-
-                #getting the  fields in the solution
-                if(type(res_struct.__dict__[sol]).__name__ == 'solution'):
-                    spe_res_struct = res_struct.__dict__[sol].__getitem__(timestep)
-                    fieldnames = dict.keys(spe_res_struct.__dict__)
-                elif(type(res_struct.__dict__[sol]).__name__ == 'solutionstep'):
-                    spe_res_struct = res_struct.__dict__[sol]
-                    fieldnames = dict.keys(spe_res_struct.__dict__)
-                elif(type(res_struct.__dict__[sol]).__name__ == 'results'):  #this is a result without steps
-                    spe_res_struct = res_struct.__dict__[sol]
-                    fieldnames = dict.keys(spe_res_struct.__dict__)
-                else:
-                    print("WARNING, solution type '{}' is not recognise, exported results might be wrong".format(type(res_struct.__dict__[sol])))
-                    spe_res_struct = res_struct.__dict__[sol]
-                    fieldnames = dict.keys(spe_res_struct.__dict__)
-
-                #Sorting scalars, vectors and tensors
-                tensors = [field for field in fieldnames if field[-2:] in ['xx', 'yy', 'xy', 'zz', 'xz', 'yz']]
-                non_tensor = [field for field in fieldnames if field not in tensors]
-                vectors = [field for field in non_tensor if field[-1] in ['x', 'y', 'z'] and field[-4:] not in ['Flux']]
-
-                #check which field is a real result and print
-                for field in fieldnames:
-                    print("Treating {}".format(field))
-                    if field in treated_res:
-                        print("{} is already done".format(field))
-                        continue
-                    elif field in vectors:
-                        print("{} is a vector".format(field))
-                        try:
-                            Vxstruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'x'])
-                            Vystruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'y'])
-                            treated_res += [field[:-1] + 'x', field[:-1] + 'y']
-                            if dim == 3:
-                                Vzstruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'z'])
-                                treated_res += field[:-1] + 'z'
-
-                        except KeyError:
-                            fieldnames += field
-                            vectors.remove(field)
-
-                        fid.write('VECTORS {} float \n'.format(field[:-1]))
-                        for node in range(0, num_of_points):
-                            Vx = cleanOutliers(Vxstruct[enveloppe_index[node]])
-                            Vy = cleanOutliers(Vystruct[enveloppe_index[node]])
-                            if dim == 3:
-                                Vz = cleanOutliers(Vzstruct[enveloppe_index[node]])
-                                fid.write('{:f} {:f} {:f}\n'.format(Vx, Vy, Vz))
-                            elif dim == 2:
-                                fid.write('{:f} {:f} {:f}\n'.format(Vx, Vy, 0))
-
-                    elif field in tensors:
-                        print("{} is a tensor".format(field))
-                        try:
-                            Txxstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xx'])
-                            Txystruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xy'])
-                            Tyystruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'yy'])
-                            treated_res += [field[:-2] + 'xx', field[:-2] + 'xy', field[:-2] + 'yy']
-                            if dim == 3:
-                                Tzzstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'zz'])
-                                Txzstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xz'])
-                                Tyzstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'yz'])
-                                treated_res += [field[:-2] + 'zz', field[:-2] + 'xz', field[:-2] + 'yz']
-
-                        except KeyError:
-                            fieldnames += field
-                            tensors.remove(field)
-
-                        fid.write('TENSORS {} float \n'.format(field[:-2]))
-                        for node in range(0, num_of_points):
-                            Txx = cleanOutliers(Txxstruct[enveloppe_index[node]])
-                            Tyy = cleanOutliers(Tyystruct[enveloppe_index[node]])
-                            Txy = cleanOutliers(Txystruct[enveloppe_index[node]])
-                            if dim == 3:
-                                Tzz = cleanOutliers(Tzzstruct[enveloppe_index[node]])
-                                Txz = cleanOutliers(Txzstruct[enveloppe_index[node]])
-                                Tyz = cleanOutliers(Tyzstruct[enveloppe_index[node]])
-                                fid.write('{:f} {:f} {:f}\n'.format(Txx, Txy, Txz))
-                                fid.write('{:f} {:f} {:f}\n'.format(Txy, Tyy, Tyz))
-                                fid.write('{:f} {:f} {:f}\n'.format(Txz, Tyz, Tzz))
-                            elif dim == 2:
-                                fid.write('{:f} {:f} {:f}\n'.format(Txx, Txy, 0))
-                                fid.write('{:f} {:f} {:f}\n'.format(Txy, Tyy, 0))
-                                fid.write('{:f} {:f} {:f}\n'.format(0, 0, 0))
-                    else:
-                        if np.size(spe_res_struct.__dict__[field]) == 1:
-                            if field == 'time':
-                                current_time = spe_res_struct.__dict__[field]
-                            #skipping integers
-                            continue
-                        elif np.size(spe_res_struct.__dict__[field]) == every_nodes:
-                            fid.write('SCALARS {} float 1 \n'.format(field))
-                            fid.write('LOOKUP_TABLE default\n')
-                            for node in range(0, num_of_points):
-                                outval = cleanOutliers(np.squeeze(spe_res_struct.__dict__[field][enveloppe_index[node]]))
-                                fid.write('{:f}\n'.format(outval))
-                        elif np.shape(spe_res_struct.__dict__[field])[0] == np.size(spe_res_struct.__dict__[field]) == every_cells:
-                            saved_cells[field] = np.squeeze(spe_res_struct.__dict__[field])
-                        else:
-                            print("format for field {}.{} is not suported, field is skipped".format(sol, field))
-    # }}}
-    # loop on arguments, if something other than result is asked, do it now {{{
-        for other in args:
-            other_struct = md.__dict__[other]
-            othernames = (dict.keys(other_struct.__dict__))
-            for field in othernames:
-                if np.size(other_struct.__dict__[field]) == 1:
-                    #skipping integers
-                    continue
-                elif np.size(other_struct.__dict__[field]) == every_nodes:
-                    fid.write('SCALARS {} float 1 \n'.format(field))
-                    fid.write('LOOKUP_TABLE default\n')
-                    for node in range(0, num_of_points):
-                        outval = cleanOutliers(other_struct.__dict__[field][enveloppe_index[node]])
-                        fid.write('{:f}\n'.format(outval))
-                elif np.shape(other_struct.__dict__[field])[0] == every_nodes + 1:
-                    #we are dealing with a forcing of some kind.
-                    forcing_time = other_struct.__dict__[field][-1, :]
-                    if any(forcing_time == current_time):
-                        forcing_index = np.where(forcing_time == current_time)
-                        forcing_val = other_struct.__dict__[field][:, forcing_index]
-                    elif forcing_time[0] > current_time:
-                        forcing_val = other_struct.__dict__[field][:, 0]
-                    elif forcing_time[-1] < current_time:
-                        forcing_val = other_struct.__dict__[field][:, -1]
-                    else:
-                        forcing_index = np.where(forcing_time < current_time)[-1][-1]
-                        delta_time = forcing_time[forcing_index + 1] - forcing_time[forcing_index]  #compute forcing Dt
-                        delta_current = current_time - forcing_time[forcing_index]  # time since last forcing
-                        ratio = delta_current / delta_time  #compute weighting factor for preceding forcing vallue
-                        forcing_evol = (other_struct.__dict__[field][:, forcing_index + 1] - other_struct.__dict__[field][:, forcing_index]) * ratio
-                        forcing_val = other_struct.__dict__[field][:, forcing_index] + forcing_evol
-                    # and now write it down
-                    fid.write('SCALARS {}_{} float 1 \n'.format(other, field))
-                    fid.write('LOOKUP_TABLE default\n')
-                    for node in range(0, num_of_points):
-                        outval = cleanOutliers(forcing_val[enveloppe_index[node]])
-                        fid.write('{:f}\n'.format(outval))
-                elif np.shape(other_struct.__dict__[field])[0] == np.size(other_struct.__dict__[field]) == every_cells:
-                    saved_cells[field] = other_struct.__dict__[field]
-                else:
-                    print("format for field {}.{} is not suported, field is skipped".format(other, field))
-                    continue
-    # }}}
-    # Now writting cell variables {{{
-        if np.size(list(saved_cells.keys())) > 0:
-            fid.write('CELL_DATA {:d} \n'.format(num_of_elt))
-            for key in list(saved_cells.keys()):
-                fid.write('SCALARS {} float 1 \n'.format(key))
-                fid.write('LOOKUP_TABLE default\n')
-                for cell in range(0, num_of_elt):
-                    outval = cleanOutliers(saved_cells[key][cell])
-                    fid.write('{:f}\n'.format(outval))
-    # }}}
-    fid.close()
 
 
